<?php
class Doprava extends Super {

  protected $id;
  protected $nazev;
  protected $cena;
  protected $popis;
  protected $stav = 1;  // default stav 

  protected $getter = array('id', 'nazev', 'cena', 'popis', 'stav');
  protected $setter = array( 'nazev', 'cena', 'popis', 'stav');
  public $validate = array(
  	'id'     => array('digits' => 'true'),
  	'nazev'  => array('required' => 'true', 'maxlength' => 65),
  	'cena'   => array('required' => 'true', 'numberDE' => 'true'),
    'stav'   => array('range' => '[0,1]' )
  );
	public $label = array(
  	'id'     => 'Id',
  	'nazev'  => 'Název',
    'popis' 	 => 'Popis',
    'stav' 	 => 'Stav'
  );
  public $valAll = array(
  	'id'     => true,
  	'nazev'  => true,
    'stav' 		 => true
  );
	public $filtry = array(
      'ID' => array(
      	'type' => 'text',
				'key'	 => 'ID',
				'sql'	 => 'num',
    		'size' => 3
    	),
      'NAZEV' => array(
      	'type' => 'text',
    		'key'	 => 'NAZEV',
    		'sql'	 => 'text',
    		'size' => 12
    	),
      'S_NAZEV' => array(
      	'type' => 'stav',
    		'key'	 => 'STAV',
    		'sql'	 => 'num'
    	),
      'UPRAVIT' => array(
      	'type' => 'submit'
    	),
      'SMAZAT' => array(
      	'type' => 'all'
    	)
    );
  public $state_validate = array();

  function __construct() {
    /*
     * stavy:
     * 1 - aktivní
     * 2 - neaktivní
     */
    $this->state_validate[1] = $this->valAll;
    $this->state_validate[0] = $this->valAll;
    
    $this->table = 'Doprava';

  }

  public function loadById($id, $hash = false, $postRestore = false) {
    $result = dibi::query('SELECT  D.*, S.NAZEV AS S_NAZEV, S.POPIS AS S_POPIS FROM ['.$this->table.'] AS D 
    	INNER JOIN STAV AS S ON S.STAV_ID = D.STAV AND ENTITA = %s
    	WHERE D.ID = %i;', $this->table, $id);

    if (count($result) == 0) {
      throw new Appliexception(1, 'Požadovaný záznam neexistuje', 'seznam', __METHOD__.' Neexistující záznam '.$id );
    }

    $row = $result->fetch()->getArrayCopy();
    $this->setFromRow($row);
    $this->my_stav = '<div title="'.$row['S_POPIS'].'" class="block_state"> '.$row['STAV'].' - '.$row['S_NAZEV'].'</div><br />';

    if ($hash) {
      $this->hash  = $this->getHash();
    } 

    $this->myStates();

    if ($postRestore) {
      $this->setFromPost();
    }
    return $this->toArray();
  }

  public function delete($id) {

  	dibi::begin();
  	dibi::query('DELETE FROM [OBJEDNAVKA] WHERE ID_DOP = %i',$id);
  	dibi::query('DELETE FROM ['.$this->table.'] WHERE ID = %i',$id);
  	dibi::commit();

  }

	public function beforeInsert() {
		$this->cena = Tools::numberFromDE($this->cena);
	}

	public function beforeUpdate() {
		$this->cena = Tools::numberFromDE($this->cena);
	}

}
?>